#!/usr/bin/perl -w 

sub usage(){
    print STDERR "Usage: $0 <src host>[:<port>] <dst host>[:<port>] <Msps> <bit> <Nch>\n";
    print STDERR " Tx start with sudp_send2. \n";
    print STDERR "  src host port: default=9902. \n";
    print STDERR "  destination host dataport: default=9901. \n";
    exit(1);
}

# use Exporter;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
use lib "$ENV{HOME}/prog/perl/module";


my @cmds= qw/"in2net=connect:192.42.120.66" "mode=ext:0xff:1" "play_rate=data:08" "net_protocol=UDP:3200000:10" "in2net=on"/;

my $cnt=0;
{
    usage() if(@ARGV <5);
    my $srcport = 9902;
    my $dstport = 9901;
    my @terms = split(/:/,shift);
    my $srchost = $terms[0];
    $srcport = $terms[1]  if(@terms > 1);

    @terms = split(/:/,shift);
    my $dsthost = $terms[0];
    $dstport = $terms[1]  if(@terms > 1);
    my $msps = shift;
    my $bit = shift;
    my $nch = shift;

    my $remote = IO::Socket::INET->new(Proto    => "tcp",
				       PeerAddr => $srchost,
				       PeerPort => $srcport );
    
    if( ! $remote){	die "Could not connect to $srchost:$srcport \n";    }

    select($remote); $|=1; # stop buffering 
    select(STDIN); $|=1; # stop buffering 
    select(STDOUT); $|=1; # stop buffering 

    ## Set Destination host
    my $msg = "in2net=connect:${dsthost}:${dstport};";
    print "Cmd: $msg\n";
    &communicate($remote,"$msg/n");
    
    ## Set Play Rate
    my $rate = $msps*$bit*$nch;
    $msg = sprintf "play_rate=data:%d;", $rate;
    print "Cmd: $msg\n";
    &communicate($remote,"$msg/n");
    
    ## Set Mode
    $msg = sprintf "mode=%d:%d:%d;", $msps, $bit, $nch;
    print "Cmd: $msg\n";
    &communicate($remote,"$msg\n");
    
    ## Tx start 
    $msg = "in2net=on;";
    print "Cmd: $msg\n";
    &communicate($remote,"$msg\n");

    close $remote;
}

sub communicate($$){
    my $socket = shift;
    my $line = shift;

    last unless(defined($socket));
    print $socket "$line\n";
    last unless(defined($socket));
    
    my $res = <$socket>;
    next unless(defined($res));
    chomp($res);
    print "Res[$cnt]: $res\n" if(defined($res));
    $cnt++;
    
}
